/*----------------------------------------------------------------------------*/
/* checkwt.c -- Main checkpoint routine, write_checkpoint, plus routines to   */
/*              write the checkpoint files containing the individuals         */
/*              (chromosomes, etc.) in the population.  Includes FileRename,  */
/*              a routine used to change the name of the individual files     */
/*              with suffix .new to suffix .ind and with suffix .neu to .ckp. */
/*              NOTE:  If the user modifies the struct individual, user must  */
/*              also modify individualsize in this file.                      */
/*----------------------------------------------------------------------------*/


#include "stdafx.h"
#include "GAWind.h"
#include "GAWindDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "external.h"

#define RETRIES 10

static FILE *fpwrite = NULL;
static int Version = 1;
static int IndCnt;
static int IndSize;
static int ChromSize;
static long states[2];

#ifdef PROTOTYPES_ACCEPTED
static BOOL InitCPWrite(char *fname, int icnt, int isize, int csize);
static BOOL EndCPWrite(char *fname);
static BOOL AddInd(struct individual*, BOOL(*)(int *, FILE*));
#else
static BOOL InitCPWrite();
static BOOL EndCPWrite();
static BOOL AddInd();
#endif








