
#include "stdafx.h"
#include "MSetar.h"
#include "MSetarDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <stdlib.h>
#include <math.h>
#include "external.h"




//Definzioni per la selezione a rango

#define RANKDEFAULT 2.0 //Must be between 1.0 and 2.0, inclusive.            */

int *ranklist = NULL;   
/* Warning:  Make sure the type this array points to matches what you tell qsort below (not   */
/*           to mention malloc().)  Also, note that a compiler with 2-byte ints might have a  */
/*           problem with pops of more than 32768 individuals.                                */

float *ranklist_probabilities = NULL; /* Precalculated probabilities for ranked items. */                        

static int *choices = NULL, nremain = 0;

//Definizioni per SUS
extern float randomperc();

//Definizioni per Tourment selection
static void reset();
/* tournament list, position in list */
static int *tourneylist, tourneypos;
static int firsttime = 1;

//definizioni per remainder
static float *fraction;


//Definzioni per inversione
int *new_field_sizes = NULL;
int *new_field_ends = NULL;
int *old_map_to_std = NULL;
int *inverse_new_map_to_std = NULL;
int *old_field_ends = NULL;
unsigned int *tempchrom = NULL;



/*----------------------------------------------------------------------------*/
/*             Single-point crossover for ordinary (non-permutation) problems */
/*             Crossover done with probability pcross; else, parents copied   */
/*             unaltered to children.  Works for binary chromosomes or those  */
/*             with alphabet cardinality >2, but NOT for permutation-type.    */
/*             Modified to work with different length fields, and still to do */
/*             crosses only at field boundaries for  non-binary chromsomes,   */ 
/*             whether field lengths same or not.                             */
/*----------------------------------------------------------------------------*/


/* Cross 2 parent strings, place in 2 child strings */
void crossover_oneptx(unsigned *parent1, unsigned *parent2, unsigned *child1, unsigned *child2, int jcross[2]) {


    int     j, k, jcross1;
    unsigned mask, temp;

    /* Do crossover with probability pcross */
    if (flip(pcross)) {
	/* Calculate after which bit to break string, based on fields. */
	/* Note that cannot break after field_ends[numfields-1], as that */
	/* is at the end of the chromosome, so produces no crossover. */
	jcross1 = field_ends[rnd(0, numfields - 2)];
	jcross[0] = jcross1;
	jcross[1] = 0;	/* Not used in one-point crossover */
	ncross++;
	for (k = 1; k <= chromsize; k++) {
	    if (jcross1 >= (k * UINTSIZE)) {
		child1[k - 1] = parent1[k - 1];
		child2[k - 1] = parent2[k - 1];
	    }
	    else if ((jcross1 < (k * UINTSIZE)) && (jcross1 > ((k - 1) * UINTSIZE))) {
		mask = 1;
		for (j = 1; j <= (jcross1 - 1 - ((k - 1) * UINTSIZE)); j++) {
		    temp = 1;
		    mask = mask << 1;
		    mask = mask | temp;
		}
		child1[k - 1] = (parent1[k - 1] & mask) | (parent2[k - 1] & (~mask));
		child2[k - 1] = (parent1[k - 1] & (~mask)) | (parent2[k - 1] & mask);
	    }
	    else {
		child1[k - 1] = parent2[k - 1];
		child2[k - 1] = parent1[k - 1];
	    }
	}
    }
    else {
	for (k = 0; k < chromsize; k++) {
	    child1[k] = parent1[k];
	    child2[k] = parent2[k];
	}
	jcross[0] = 0;
	jcross[1] = 0;
    }
}


/*----------------------------------------------------------------------------*/
/*             Two-point (or circular) crossover operator for ordinary        */
/*             (binary, non-permutation) problems:  treats chromosome as a    */
/*             ring, with probability pcross, child1 gets part from locus     */
/*             jcross1 to jcross2 from parent 2, rest from parent 1; child 2  */
/*             is reverse; else, children are copied unaltered from parents.  */
/*             Works for binary chromosomes or those with alphabet cardinality*/
/*             >2, but not for permutation-type problems.                     */
/*             Modified 3/06 by C.D to cross at field boundaries even if use  */
/*             different length fields.  (probab. is indep of fld lengths)    */
/*----------------------------------------------------------------------------*/



/* Cross 2 parent strings, place in 2 child strings */

void crossover_twoptx(unsigned *parent1, unsigned *parent2, unsigned *child1, unsigned *child2, int jcross[2]) {

    int     j, k, jcross1, jcross2;
    unsigned mask, temp;

    /* Do crossover with probability pcross */
    if (flip(pcross)) {
	jcross1 = field_ends[rnd(0, numfields - 1)];   /* Cross at any field */
	/* boundary */
	jcross2 = field_ends[rnd(0, numfields - 1)];	/* same */
	ncross++;
	if (jcross1 > jcross2) {
	    j = jcross2;
	    jcross2 = jcross1;
	    jcross1 = j;
	}
	jcross[0] = jcross1;
	jcross[1] = jcross2;
	for (k = 1; k <= chromsize; k++) {
	    if (jcross1 >= (k * UINTSIZE)) {
		child1[k - 1] = parent1[k - 1];
		child2[k - 1] = parent2[k - 1];
	    }

	    else if ((jcross1 < (k * UINTSIZE)) && (jcross1 > ((k - 1) * UINTSIZE))) {
		mask = 1;
		for (j = 1; j <= (jcross1 - 1 - ((k - 1) * UINTSIZE)); j++) {
		    temp = 1;
		    mask = mask << 1;
		    mask = mask | temp;
		}
		child1[k - 1] = (parent1[k - 1] & mask) | (parent2[k - 1] & (~mask));
		child2[k - 1] = (parent1[k - 1] & (~mask)) | (parent2[k - 1] & mask);
		if (jcross2 < (k * UINTSIZE)) {
		    /* handle case when both in same unsigned int, so already */
		    /* did some work into child1 and child2.                  */
		    mask = 1;
		    for (j = 1; j <= (jcross2 - 1 - ((k - 1) * UINTSIZE)); j++) {
			temp = 1;
			mask = mask << 1;
			mask = mask | temp;
		    }
		    child1[k - 1] = (child1[k - 1] & mask) | (parent1[k - 1] & (~mask));
		    child2[k - 1] = (parent2[k - 1] & (~mask)) | (child2[k - 1] & mask);
		}
	    }

	    else if (jcross2 >= (k * UINTSIZE)) {
		child1[k - 1] = parent2[k - 1];
		child2[k - 1] = parent1[k - 1];
	    }

	    else if ((jcross2 < (k * UINTSIZE)) && (jcross2 > ((k - 1) * UINTSIZE))) {
		mask = 1;
		for (j = 1; j <= (jcross2 - 1 - ((k - 1) * UINTSIZE)); j++) {
		    temp = 1;
		    mask = mask << 1;
		    mask = mask | temp;
		}
		child2[k - 1] = (parent1[k - 1] & mask) | (parent2[k - 1] & (~mask));
		child1[k - 1] = (parent1[k - 1] & (~mask)) | (parent2[k - 1] & mask);
	    }
	    else {
		child2[k - 1] = parent2[k - 1];
		child1[k - 1] = parent1[k - 1];
	    }

	}
    }
    else {
	for (k = 0; k < chromsize; k++) {
	    child1[k] = parent1[k];
	    child2[k] = parent2[k];
	}
	jcross[0] = 0;
	jcross[1] = 0;
    }
}





/*-------------------------------------------------------------------------*/
/* Uniform crossover operator for ordinary (binary string or               */
/* larger alphabet (non-permutation) problems.  Not for permutation-type   */
/* representations.  Uses simpler, faster logic for binary chromosomes.    */
/* Modified 3/06 by C.D to handle different length fields, crossing only   */
/* at field boundaries.                                                    */
/*-------------------------------------------------------------------------*/


void crossover_uniform(unsigned *parent1, unsigned *parent2, unsigned *child1, unsigned *child2, int jcross[2]) {

	int counter1, counter2, bitsleft, UintSize, fieldnum, lclfldlength; 
    int prevfldlength;
    int rememberflip;
    unsigned mask;

	jcross[0]=0; /* not used in uniform crossover, so report 0 */
    jcross[1]=0; /* not used in uniform crossover, so report 0 */

    if (flip(pcross)) {
		ncross++;
		if (alpha_size == 2) {
			/* BINARY ALPHABET, CROSS ANYWHERE */
	for (counter1=0; counter1<chromsize; counter1++) {
	    child1[counter1]=0;
	    child2[counter1]=0;
	    mask=1;
	    for (counter2=1;
		 (counter2<=UINTSIZE)
		    &&(counter2+(counter1)*UINTSIZE<=(unsigned)lchrom);
		 counter2++) {

		if (flip(0.5)) {
		    child1[counter1]=child1[counter1] | (mask & parent1[counter1]);
		    child2[counter1]=child2[counter1] | (mask & parent2[counter1]);
		}
		else {
		    child1[counter1]=child1[counter1] | (mask & parent2[counter1]);
		    child2[counter1]=child2[counter1] | (mask & parent1[counter1]);
		}
		mask = mask << 1;
	    }
	}
    }
    else {
	/* non-binary fields, alphabet size doesn't necessarily use all   */
	/* possible bit combinations, must cross on field boundaries,     */
	/* to perform valid crossovers.  Requires care at unsigned word   */
	/* boundaries.                                                    */
	bitsleft = 0;
	child1[0] = 0;
	child2[0] = 0;
	fieldnum = 0;
	lclfldlength = field_ends[0];
        prevfldlength = 0;
	for (counter1=0; counter1<chromsize; counter1++) {   /* which word */
	    for (counter2=bitsleft;                /* starting bit in word */
		 (counter2<UINTSIZE)
		    &&(counter2+(counter1)*UINTSIZE<lchrom);
                 counter2 += prevfldlength) {
	        mask = 1;
                mask = (mask << lclfldlength) - 1;
	        mask = mask << counter2;

		if ((rememberflip = flip(0.5))) {
		    child1[counter1]=child1[counter1] | (mask & parent1[counter1]);
		    child2[counter1]=child2[counter1] | (mask & parent2[counter1]);
		}
		else {
		    child1[counter1]=child1[counter1] | (mask & parent2[counter1]);
		    child2[counter1]=child2[counter1] | (mask & parent1[counter1]);
		}
                fieldnum++;
                prevfldlength = lclfldlength;
		lclfldlength = field_ends[fieldnum] - field_ends[fieldnum - 1];
	    }
	    /* field may cross word boundary -- fix up if does (else NOP) */
	    bitsleft = counter2 % UINTSIZE;
            mask = 1;
	    mask = (mask << bitsleft) - 1;
	    /* Below, finishing current field in beginning of next word */
	    if (counter1 < chromsize - 1) {
		child1[counter1+1] = 0;
		child2[counter1+1] = 0;

		if (rememberflip) {
		    child1[counter1+1]=child1[counter1+1] | (mask & parent1[counter1+1]);
		    child2[counter1+1]=child2[counter1+1] | (mask & parent2[counter1+1]);
		}
		else {
		    child1[counter1+1]=child1[counter1+1] | (mask & parent2[counter1+1]);
		    child2[counter1+1]=child2[counter1+1] | (mask & parent1[counter1+1]);
		}
	    }
            /* Now working with all but "bitsleft" bits of new word. */
            
	}
    }
 }
 else {
    for (counter1 = 0; counter1 < chromsize; counter1++) {
	child1[counter1] = parent1[counter1];
	child2[counter1] = parent2[counter1];
    }
 }

}



/*----------------------------------------------------------------------------*/
/*          Cycle crossover (for permutation-type problems), as described in  */
/*          Goldberg book.  Also includes FirstNth(), a function called by    */
/*          permutation-type mutation operators.  This assures that compatible*/
/*          permutation and crossover operators are loaded for a permutation- */
/*          type problem.  Returns jcross{0],[1] as 0.  */
/*----------------------------------------------------------------------------*/


/* Cross 2 parent strings, place in 2 child strings */
void crossover_cycle(unsigned *parent1, unsigned *parent2, unsigned *child1, unsigned *child2, int jcross[2]) {


    int     i, j, k, cnt, realcnt;
    int     first;

    /* Do crossover with probability pcross */
    if (flip(pcross)) {
		ncross++;
		chromtointarray(intarray1, parent1);
		chromtointarray(intarray2, parent2);
		chromtointarray(intarraybak1, parent1);
		chromtointarray(intarraybak2, parent2);

		jcross[0] = 0;
        jcross[1] = 0;
	    /* fprintf(stderr,"\n")    ; for     (i=0;i<numfields;i++)
	     * fprintf(stderr,"%3d ",intarray1[i])     ; fprintf(stderr,"\n")
	     * ; for     (i=0;i<numfields;i++) fprintf(stderr,"%3d
	     * ",intarray2[i]) ; */

		for (i = 0; i < numfields; i++) tmparray[i] = 1;

		first = intarraybak1[0];
		k = intarraybak2[0];
		tmparray[0] = 0;
	    while (1) {
			for (j = 0; j < numfields; j++) {
				if (k == intarraybak1[j]) {
					k = intarraybak2[j];
		            tmparray[j] = 0;
		            break;
				}
			}
			if (first == k) break;
		}

		/* fprintf(stderr,"\n"); */
		for (i = 0; i < numfields; i++) {
			/* fprintf(stderr," %d",tmparray[i]); */
			if (tmparray[i]) {
				intarray1[i] = intarraybak2[i];
		        intarray2[i] = intarraybak1[i];
			}
		}

		/* fprintf(stderr,"\nResult:\n")   ; for     (i=0;i<numfields;i++)
	     * fprintf(stderr,"%3d ",intarray1[i])     ; fprintf(stderr,"\n")
	     * ; for     (i=0;i<numfields;i++) fprintf(stderr,"%3d
	     * ",intarray2[i]) ; fprintf(stderr,"\n")    ; bioskey(0)      ; */

		intarraytochrom(intarray1, child1);
	    intarraytochrom(intarray2, child2);
	}
    else {
		for (k = 0; k < chromsize; k++) {
			child1[k] = parent1[k];
			child2[k] = parent2[k];
		}
		jcross[0] = 0;
	    jcross[1] = 0;
    }
}



/*----------------------------------------------------------------------------*/
/*           Uniform Order-Based Crossover (see Davis, Handbook of Genetic    */
/*           Algorithms) for use in solving permutation-type                  */
/*           problems.  Also includes FirstNth(), a function called by        */
/*           mutation operators for permutation-type problems, to assure that */
/*           compatible crossover and mutation operators are loaded.          */
/*----------------------------------------------------------------------------*/



/* Cross 2 parent strings, place in 2 child strings */

void crossover_uniform_order(unsigned *parent1, unsigned *parent2, unsigned *child1, unsigned *child2, int jcross[2]) {

    int     i, j, k, cnt, realcnt;

    /* Do crossover with probability pcross */
    if (flip(pcross)) {
	/* Notice : this function returns jcross entries as 0, for the */
	/* position of crossover (jcross not useful). */
	ncross++;
	chromtointarray(intarray1, parent1);
	chromtointarray(intarraybak1, parent1);
	chromtointarray(intarray2, parent2);
	chromtointarray(intarraybak2, parent2);
	for (i = 0; i < numfields; i++)
	    randomlst[i] = rnd(0, 1);
	/* here generate child1. */
	cnt = 0;
	realcnt = 0;
	for (i = 0; i < numfields; i++)
	    if (randomlst[i] == 0)
		tmparray[cnt++] = i;
	for (i = 0; i < numfields; i++)
	    for (j = 0; j < cnt; j++)
		if (intarraybak2[i] == intarraybak1[tmparray[j]])
		    intarray1[tmparray[realcnt++]] = intarraybak1[tmparray[j]];
	/* here generate child2. */
	cnt = 0;
	realcnt = 0;
	for (i = 0; i < numfields; i++)
	    if (randomlst[i] == 1)  {
		tmparray[cnt++] = i;
	    }
	for (i = 0; i < numfields; i++)
	    for (j = 0; j < cnt; j++)
		if (intarraybak1[i] == intarraybak2[tmparray[j]]) {
		    intarray2[tmparray[realcnt++]] = intarraybak2[tmparray[j]];
		}
	intarraytochrom(intarray1, child1);
	intarraytochrom(intarray2, child2);
    }
    else {
	for (k = 0; k < chromsize; k++) {
	    child1[k] = parent1[k];
	    child2[k] = parent2[k];
	}
    }
    jcross[0] = 0;
    jcross[1] = 0;
}


/*----------------------------------------------------------------------------*/
/*           PMX:(Partially Matched Crossover) operator, for permutation-type */
/*                 problems, as described in Goldberg book.  File also        */
/*                 includes FirstNth(), a routine called by permutation-type  */
/*                 mutation operators, to assure that user loads compatible   */
/*                 crossover and mutation operators when doing permutation-   */
/*                 type problems                                              */
/*----------------------------------------------------------------------------*/



/* Perform PMX, "partially matched crossover," as described in Goldberg book */
/* Cross 2 parent strings, place in 2 child strings */

void crossover_pmx(unsigned *parent1, unsigned *parent2, unsigned *child1, unsigned *child2, int jcross[2]) {

	int     i, j, k, cnt, realcnt;
    int     start, end;

    /* Do crossover with probability pcross */
    if (flip(pcross)) {
	ncross++;
	chromtointarray(intarray1, parent1);
	chromtointarray(intarraybak1, parent1);
	chromtointarray(intarray2, parent2);
	chromtointarray(intarraybak2, parent2);

	j = rnd(0, numfields - 1);
	k = rnd(0, numfields - 1);
	start = (j < k) ? j : k;
	end = (j > k) ? j : k;

	jcross[0] = start;
	jcross[1] = end;

	/* fprintf(stderr,"\n")    ; for     (i=0;i<numfields;i++)
	 * fprintf(stderr,"%d ",intarray1[i])      ; fprintf(stderr,"\n")
	 * ; for     (i=0;i<numfields;i++) fprintf(stderr,"%d ",intarray2[i])
	 * ; fprintf(stderr,"\nstart:%d end:%d",start,end)   ; */
	/* now generate child1. */
	for (i = start; i <= end; i++)
	    tmparray[i] = 1;
	for (i = 0; i < start; i++)
	    for (j = start; j <= end; j++)
		if (intarraybak1[i] == intarraybak2[j]) {
		    intarray1[i] = intarraybak1[j];
		    tmparray[j] = 0;
		}
	for (i = end + 1; i < numfields; i++)
	    for (j = start; j <= end; j++)
		if (intarraybak1[i] == intarraybak2[j]) {
		    intarray1[i] = intarraybak1[j];
		    tmparray[j] = 0;
		}
	for (i = start; i <= end; i++)
	    if (tmparray[i] == 0)
		intarray1[i] = intarraybak2[i];

	/* now generate child2. */
	for (i = start; i <= end; i++)
	    tmparray[i] = 1;
	for (i = 0; i < start; i++)
	    for (j = start; j <= end; j++)
		if (intarraybak2[i] == intarraybak1[j]) {
		    intarray2[i] = intarraybak2[j];
		    tmparray[j] = 0;
		}
	for (i = end + 1; i < numfields; i++)
	    for (j = start; j <= end; j++)
		if (intarraybak2[i] == intarraybak1[j]) {
		    intarray2[i] = intarraybak2[j];
		    tmparray[j] = 0;
		}
	for (i = start; i <= end; i++)
	    if (tmparray[i] == 0)
		intarray2[i] = intarraybak1[i];
	/* fprintf(stderr,"\nResult:\n")   ; for     (i=0;i<numfields;i++)
	 * fprintf(stderr,"%d ",intarray1[i])      ; fprintf(stderr,"\n")
	 * ; for     (i=0;i<numfields;i++) fprintf(stderr,"%d ",intarray2[i])
	 * ; fprintf(stderr,"\n")    ; bioskey(0)      ; */
	intarraytochrom(intarray1, child1);
	intarraytochrom(intarray2, child2);
    }
    else {
	for (k = 0; k < chromsize; k++) {
	    child1[k] = parent1[k];
	    child2[k] = parent2[k];
	}
	jcross[0] = 0;
	jcross[1] = 0;
    }
}


/*----------------------------------------------------------------------------*/
/*         Order Crossover, for Permutation-type problems, as described in    */
/*         Goldberg book.  File also includes FirstNth, a function called by  */
/*         permutation-type mutation operators, to assure that compatible     */
/*         crossover and mutation operators are loaded.                       */
/*----------------------------------------------------------------------------*/



/* Performs order crossover,  as described in Goldberg book.*/
/* Cross 2 parent strings, place in 2 child strings */

void crossover_order(unsigned *parent1, unsigned *parent2, unsigned *child1, unsigned *child2, int jcross[2]) {

	int     i, j, k, cnt, realcnt;
    int     start, end, tmpcnt, subcnt;

    /* Do crossover with probability pcross */
    if (flip(pcross)) {
	ncross++;
	chromtointarray(intarray1, parent1);
	chromtointarray(intarraybak1, parent1);
	chromtointarray(intarray2, parent2);
	chromtointarray(intarraybak2, parent2);

	j = rnd(0, numfields - 1);
	k = rnd(0, numfields - 1);
	start = (j < k) ? j : k;
	end = (j > k) ? j : k;

	jcross[0] = start;
	jcross[1] = end;

	/* fprintf(stderr,"\n")    ; for     (i=0;i<numfields;i++)
	 * fprintf(stderr,"%d ",intarray1[i])      ; fprintf(stderr,"\n")
	 * ; for     (i=0;i<numfields;i++) fprintf(stderr,"%d ",intarray2[i])
	 * ; fprintf(stderr,"\nstart:%d end:%d",start,end)   ; */
	/* now generate child1. */
	subcnt = 0;
	tmpcnt = 0;
	for (i = start; i <= end; i++)
	    randomlst[i] = 1;
	for (i = start; i <= end; i++)
	    intarray1[tmpcnt++] = intarraybak1[i];
	for (i = end + 1; i < numfields; i++) {
	    for (j = start; j <= end; j++)
		if (intarraybak1[i] == intarraybak2[j]) {
		    randomlst[j] = 0;
		    break;
		}
	    if (j > end)
		tmparray[subcnt++] = intarraybak1[i];
	}
	for (i = 0; i < start; i++) {
	    for (j = start; j <= end; j++)
		if (intarraybak1[i] == intarraybak2[j]) {
		    randomlst[j] = 0;
		    break;
		}
	    if (j > end)
		tmparray[subcnt++] = intarraybak1[i];
	}
	for (i = start; i <= end; i++)
	    if (randomlst[i] == 0)
		intarray1[tmpcnt++] = intarraybak2[i];
	for (i = 0; i < subcnt; i++)
	    intarray1[tmpcnt++] = tmparray[i];
	/* now generate child2. */
	subcnt = 0;
	tmpcnt = 0;
	for (i = start; i <= end; i++)
	    randomlst[i] = 1;
	for (i = start; i <= end; i++)
	    intarray2[tmpcnt++] = intarraybak2[i];
	for (i = end + 1; i < numfields; i++) {
	    for (j = start; j <= end; j++)
		if (intarraybak2[i] == intarraybak1[j]) {
		    randomlst[j] = 0;
		    break;
		}
	    if (j > end)
		tmparray[subcnt++] = intarraybak2[i];
	}
	for (i = 0; i < start; i++) {
	    for (j = start; j <= end; j++)
		if (intarraybak2[i] == intarraybak1[j]) {
		    randomlst[j] = 0;
		    break;
		}
	    if (j > end)
		tmparray[subcnt++] = intarraybak2[i];
	}
	for (i = start; i <= end; i++)
	    if (randomlst[i] == 0)
		intarray2[tmpcnt++] = intarraybak1[i];
	for (i = 0; i < subcnt; i++)
	    intarray2[tmpcnt++] = tmparray[i];
	/* fprintf(stderr,"\nResult:\n")   ; for     (i=0;i<numfields;i++)
	 * fprintf(stderr,"%d ",intarray1[i])      ; fprintf(stderr,"\n")
	 * ; for     (i=0;i<numfields;i++) fprintf(stderr,"%d ",intarray2[i])
	 * ; fprintf(stderr,"\n")    ; bioskey(0)      ; */
	intarraytochrom(intarray1, child1);
	intarraytochrom(intarray2, child2);
    }
    else {
	for (k = 0; k < chromsize; k++) {
	    child1[k] = parent1[k];
	    child2[k] = parent2[k];
	}
	jcross[0] = 0;
	jcross[1] = 0;
    }
}


void crossover_app(unsigned *parent1, unsigned *parent2, unsigned *child1, unsigned *child2, int jcross[2]){


}

int FirstNth(int *array, int k, int start, int end) {


    int     cnt, i;

    cnt = 0;
    for (i = start; i <= end; i++) {
		if (array[i]) cnt++;
	}

    if (!cnt) {
		fprintf(stderr, "\nTemplate is wrong in FirstNth.\n");
		exit(-1);
    }

    cnt = k % cnt;
    for (i = start; i <= end; i++) {
		if (array[i]) {
			if (!cnt)
				return i;
			else
				cnt--;
		}
    }
    fprintf(stderr, "\nTemplate wrong in FirstNth.\n");
    exit(-1);
}



//************************************* Mutation *******************************

/*----------------------------------------------------------------------------*/
/*               Single-bit and field-wise mutation operators for ordinary    */
/*               (non-permutation) problems. Mutates each locus (field) with  */ 
/*               probability pmutation, the prob. of mut. per field           */
/*               (i.e., per BIT, if a binary problem; otherwise, per field,   */
/*               producing a legal code within the specified alpha_size or    */
/*               field_lengths[i]).                                           */
/*               Modified 2/06 to speed up, avoid loops.                      */
/*               Modified 3/06 to handle fields with different lengths        */
/*               (Also uses new getfield, putfield to do it.                  */
/*----------------------------------------------------------------------------*/





/* Mutate each allele (bit) with probability pmutation, count # of mutations */
/* Actually implemented by using derived probability of 1 or more mutations  */
/* on this chromosome, flipping to see if get one, if so, doing it, flipping */
/* again, continuing until DON'T get one, for reasonable mutation rates (see */
/* below). */

void mutation_bit(unsigned *child) {

    int mut_locus, wordnumber, bitinword;
    unsigned int mask;
    /* Make next two static and test so only compute p_anymuts once for any */
    /* given pmutation. */
    int i;
    static float p_anymuts;
    static double local_pmutation;

    if(local_pmutation != pmutation) {
        local_pmutation = pmutation;
	if (local_pmutation >= 1.0) {
	    fprintf(stderr, "\n*** Bad mutation rate specified, exiting.\n");
	    exit(-1);
	}
	p_anymuts = 1.0
		    - (float)pow((double)(1.0 - pmutation), (double)lchrom);
    }
    if (p_anymuts < 0.8) {
      /* Will do [none - few] mutations/chromosome, so it is reasonable to */
      /* approximate the process by sampling with replacement, just doing */
      /* mutations at random locations until flip (probability of further */
      /* mutations) comes up "no".  This is quite fast. */
 
      while(flip(p_anymuts)) {
        mut_locus = rnd(0, (lchrom - 1));
        wordnumber = mut_locus/UINTSIZE;
	bitinword = mut_locus%UINTSIZE;
	mask = 1 << bitinword;
	child[wordnumber] ^= mask;
	nmutation++;
      }
    }
    else {
      /* In this case, sampling with replacement not a very good approx., */
      /* so just go along chromosome and,                                 */
      /* at each locus, with probability pmutation, do a mutation there.  */
      /* NOTE:  this case generally represents a MISUSE of the mutation */
      /* operator, in the GA context, as mutation will likely overwhelm */
      /* selection and reproduction, causing "scrambling" of the information, */
      /* and lack of ability to learn and converge.  But this will prevent */
      /* "infinite" loops in the code from oversized mutation probabilities. */
      for (i=0;i<numfields;i++) {
        if (flip(pmutation)) {
          wordnumber = i/UINTSIZE;
	  bitinword = i%UINTSIZE;
	  mask = 1 << bitinword;
	  child[wordnumber] ^= mask;
	  nmutation++;
        }
      }

    }
}


/* Mutate chosen fields to uniform randomly chosen members of those fields'  */
/* legal alphabets, with probability pmutation; count # of mutations         */
/* Actually implemented by using derived probability of 1 or more mutations  */
/* on this chromosome, flipping to see if get one, if so, doing it, flipping */
/* again, continuing until DON'T get one. */
/* NOTE:  probability of mutation is same for each field, regardless of its  */
/* length (not realistic in nature, but usual in GA).                        */

void field_mutation_bit(unsigned *child) {
    int mut_field, allele, new_allele, i;
    /* Make next two static and test so only compute p_anymuts once for any */
    /* given pmutation. */
    static float p_anymuts;
    static double local_pmutation;

    if(local_pmutation != pmutation) {
	local_pmutation = pmutation;
	if (local_pmutation >= 1.0) {
	    fprintf(stderr, "\n*** Bad mutation rate specified, exiting.\n");
	    exit(-1);
	}
	p_anymuts = 1.0
		    - (float)pow((double)(1.0 - pmutation), (double)numfields);
    }
    if (p_anymuts < 0.8) {
      /* Will do [none - few] mutations/chromosome, so it is reasonable to */
      /* approximate the process by sampling with replacement, just doing */
      /* mutations at random locations until flip (probability of further */
      /* mutations) comes up "no".  This is quite fast. */

      while(flip(p_anymuts)) {
	mut_field = rnd(0, (numfields - 1));
	allele = getfield(mut_field, numfields, child);
	while ((new_allele = rnd(0, field_sizes[mut_field] - 1)) == allele) {
	}
	putfield(mut_field, numfields, new_allele, child);

	nmutation++;
      }
    }
    else {
      for (i=0;i<numfields;i++) {
        if (flip(pmutation)) {
	  allele = getfield(i, numfields, child);
	  while ((new_allele = rnd(0, field_sizes[i] - 1)) == allele) {
  	  }
	  putfield(i, numfields, new_allele, child);

	  nmutation++;
        }
      } 
    }
}


/*----------------------------------------------------------------------------*/
/*               Multi-bit spatially correlated mutation operator for ordinary*/
/*               (non-permutation) problems.  With probability p_multimut     */
/*               it randomly sets an adjacent set of 1 or more loci (bits or  */
/*               fields), where the number of loci randomly set is Poisson    */
/*               distributed with probability                                 */
/*                      1./avg_mut_width -- same as saying expected           */
/*               number of adjacent mutations is avg_mut_width.               */
/*               Treats chromosome as circular.                               */
/*               Note:  crude, slow -- could be speeded up with some          */
/*               attention, as I did ordinary mutation earlier.               */
/*----------------------------------------------------------------------------*/


/* This function called for BINARY CHROMOSOME CASE:  alpha_size = 2 */
void mutation_multiple(unsigned *child) {


    int start, end, change_length, mut_locus, wordnumber, bitinword, i;
    float prob_wider;
    unsigned int mask;

    /* TEMPORARILY, until revise code so load ALL operators and choose from */
    /* among all at run time, just use pmutation to run this one, instead.  */
    p_multimut = pmutation;

    /* First, decide whether or not to do a mutation for this chromosome, using p_multimut.*/ 
    if (flip(1. - p_multimut)) 
		return;
	else {
		/* Doing one with exp width avg_mut_width, so figure out how many bits to change (may be 0) */
		prob_wider = (1. - 1./avg_mut_width);
		change_length = 0;
		while (flip(prob_wider)) {
			change_length++; 
		}
		/* Note:  expectation breaks down if avg_mut_width nears numfields */
		if (change_length >= numfields) change_length = numfields;
		if (change_length == 0) return;
		/* Figure out where to start, stop the multi-bit mutation (at this point, it is not 0-length).*/
        /* Pick start point (NOTE:  will wrap chrom around end): */
		start = rnd(0, numfields-1);
		end = start + change_length - 1;
		/* Do the mutation: */
		/* writechrom(child); */
		for (i=start; i<=end;i++) {
			if (flip(0.5)) {
				/* NOTE:  Do the bit flip only with 50% probability; otherwise, */
				/* only get start substring or its complement -- too drastic. */
				mut_locus = i % numfields;
				wordnumber = mut_locus/UINTSIZE;
				bitinword = mut_locus%UINTSIZE;
				mask = 1 << bitinword;
				child[wordnumber] ^= mask;
			}
		}
		nmutation++;
		/* writechrom(child); */
		/* fprintf(outfp, "\n"); */
    }
}


/* Same idea as routine above, but for non-binary fields -- must keep each   */
/* of one or more fields within its allowable range, field_sizes[i].         */
/* Mutate chosen fields to uniform randomly chosen members of those fields'  */
/* legal alphabets, with probability p_multimut; count # of mutations.       */
/* NOTE:  probability of mutation is same for each field, regardless of its  */
/* length (not realistic in nature, but usual in GA).                        */

void field_mutation_multiple(unsigned *child) {

    int start, end, change_length, new_allele, mut_field, allele, i;
    float prob_wider;
    unsigned int mask;

    /* TEMPORARILY, until revise code so load ALL operators and choose from */
    /* among all at run time, just use pmutation to run this one, instead.  */
    p_multimut = pmutation;

    /* First, decide whether or not to do a mutation for this chromosome,    */
    /* using p_multimut.                                                     */ 
    if (!flip(p_multimut)) 
		return;
    else {
		/* Doing one with exp width avg_mut_width, so figure out how many    */
		/* fields to change (may be 0) */
		prob_wider = (1. - 1./avg_mut_width);
		change_length = 0;
        while (flip(prob_wider)) {
			change_length++;  
		}
		/* Note:  expectation breaks down if avg_mut_width nears numfields */
	    if (change_length >= numfields) change_length = numfields;
	    if (change_length == 0) return;
	    /* Figure out where to start, stop the multi-field mutation (at this */
	    /* point, it is not 0-length).                                     */
        /* Pick start point (NOTE:  will wrap chrom around end): */
	    start = rnd(0, numfields-1);
        end = start + change_length - 1;
	    /* writefields(child); */
	    /* Do the mutation: */
        for (i=start; i<=end;i++) {
			mut_field = i % numfields;
	        /* getfield numbers fields in {0, numfields-1} */
	        allele = getfield(mut_field, numfields, child);
	        /* Don't FORCE each field to change, just ALLOW it to. */
            new_allele = rnd(0, field_sizes[mut_field] - 1);
	        putfield(mut_field, numfields, new_allele, child);
		}
		nmutation++;
	   /* writefields(child); */
	   fprintf(outfp, "\n");
	}
    
}


/*----------------------------------------------------------------------------*/
/*               Random Sublist Scramble Mutation -- a mutation operator for  */
/*               use on permutation-type problems.  As described in Davis,    */
/*               Handbook of Genetic Algorithms.  Does a random shuffle of    */
/*               the fields between two randomly selected points on the       */
/*               chromosome.                                                  */
/*----------------------------------------------------------------------------*/


/* Perform Random Sublist Scramble Mutation (as suggested by Davis, Handbook  */
/* of Genetic Algorithms), on an individual,  with probability pmutation, and */
/* count # of mutations.  Note... in this case, pmutation is interpreted as   */
/* probability PER INDIVIDUAL, NOT the usual probability PER BIT.             */
/* NOTE:  If you use this mutation operator, you must also select ONE of the  */
/* permutation-type crossover operators (their files contain FirstNth(), which*/
/* is called here).                                                           */
void mutation_scramble(unsigned *child) {


    int     i, j, k;
    int     cnt, start, end;

    if (!flip(pmutation))
	return;
    nmutation++;

    j = rnd(0, numfields - 1);
    k = rnd(0, numfields - 1);
    start = (j < k) ? j : k;
    end = (j > k) ? j : k;
    cnt = end - start + 1;

    for (i = 0; i < numfields; i++)
	tmparray[i] = (i < start || i > end) ? 0 : 1;

    chromtointarray(intarray1, child);
    chromtointarray(intarraybak1, child);

    for (i = start; i <= end; i++) {
	k = rnd(0, cnt - 1);
	j = FirstNth(tmparray, k, start, end);
	tmparray[j] = 0;
	intarray1[i] = intarraybak1[j];
    }

    intarraytochrom(intarray1, child);
}


/* DUMMY FUNCTION for compatibility with non-perm.-type mutation operators. */
void field_mutation_scramble(unsigned *child) {

}


/*----------------------------------------------------------------------------*/
/*      Swap Mutation via swapping of two randomly selected fields, from a    */
/*      permutation-type chromosome.                                          */
/*----------------------------------------------------------------------------*/




/* Perform a swap of two randomly selected fields of an individual,  with     */
/* probability pmutation, and count the number of mutations.  Note... in this */
/* case, pmutation is interpreted as probability PER INDIVIDUAL, NOT the      */
/* usual probability PER BIT.  This operator may be used ONLY for permutation */
/* problems (permproblem = 1).                                                */

void mutation_swap(unsigned *child) {

    int     j, k, temp1, temp2, *dummy;


    if (!flip(pmutation))
	return;
    nmutation++;

    /* Dummy call to assure compatible crossover operator is loaded in */
    /* makefile. */
    if (FALSE) FirstNth(dummy, k, k, k); /* Never called */

    j = rnd(0, numfields - 1);
    k = rnd(0, numfields - 1);

    temp1 = getfield(j, numfields, child);
    temp2 = getfield(k, numfields, child);
    putfield(j, numfields, temp2, child);
    putfield(k, numfields, temp1, child);
}

/* DUMMY FUNCTION for compatibility with non-perm.-type mutation operators. */
void field_mutation_swap(unsigned *child) {

}


//Mutazione definita dall'utente
void mutation_app(unsigned *child){

}

void field_mutation_app(unsigned *child) {

}



// ************************************* Selezione *****************************************


/*----------------------------------------------------------------------------*/
/* rnkslect.c - Rank-based selection                                          */
/*                                                                            */
/*                                                                            */
/*     Once the population is ranked, there are various ways to use this      */
/* information.  Here, we use linear ranking (Baker 1975) which gives this    */
/* formula for probability p of (ranked from 1..Lambda) individual i:         */
/*           1                                   i - 1                        */
/*   p(i) = --- * (nu_max - (nu_max - nu_min) * ------- )                     */
/*          Lam                                 Lam - 1                       */
/*                                                                            */
/*   where 1 <= nu_max <= 2, and nu_min = 2 - nu_max.                         */
/*                                                                            */
/*     Using the formula for the sum of the numbers from 1                    */
/* to N = (N + 1) * N / 2, this quickly reduces to 1 by simple algebra.       */
/* This formula gives a weighted value from nu_max = 2, wherein the term      */
/* of nu_max - nu_min reduces to 2, and thus the best individual has maximal  */
/* weight 2 times the mean weight, to nu_max = 1, (so nu_max - nu_min also    */
/* equals 1), so the individuals all have equal probability 1/Lam.            */
/*                                                                            */
/*     The actual selection used is suselect.c.  However, the selection is    */
/* summed over the rank-associated probabilities, not the fitnesses.          */
/*                                                                            */
/*     For most GA problems, the evaluation function uses 90+% of the         */
/* computational power, so the time spent (quick)sorting here is really       */
/* a minor consideration.                                                     */
/*----------------------------------------------------------------------------*/

  

/* Malloc a block of mem for popsize ints = index into population. */   
/* Also get a rank factor. */                   
void select_memory_rank()  {  
	

    int i;
    char ch;
    float oneoverpopsize;
    size_t nbytes = 0;
    float rankfactor = RANKDEFAULT;

    if(scalemult > 1.) { /* This factor naturally serves this function when */
                        /* rank-based scaling is done, and it makes no sense */
                        /* to do window scaling or linear scaling, so it is */
                        /* used in this way. */
        rankfactor = scalemult;
    }
    else {
        fprintf(stderr, "\n***ERROR:  Window scaling and rank-based selection");
        fprintf(stderr, " are incompatible.\nParameter scalemult must be >");
        fprintf(stderr, " 1.0 to use rank-based selection.\nTurn off window");
        fprintf(stderr, " scaling and set");
        fprintf(stderr, " 1.0 < scalemult <=2.0\nor use a different form of");
        fprintf(stderr, " selection\n\n");
        exit(-1);
    } 

    nbytes = popsize * sizeof(int);
    if ((choices = (int *) malloc(nbytes)) == NULL)
	    nomemory("choices");

    if (ranklist_probabilities)
    	{
    	 free(ranklist_probabilities);
    	 ranklist_probabilities = NULL;
    	}
    /* Values filled in later. */
    if ((ranklist_probabilities = (float *) malloc((size_t) (((size_t) popsize) * sizeof(float)))) == NULL)
    	nomemory("ranklist_probabilities");
    	
    

    if (ranklist)  /* Should NEVER be a non-NULL garbage pointer. */
    	{
    	 free(ranklist);
    	 ranklist = NULL;
    	}
    nbytes = ((size_t) popsize) * sizeof(int);
    if ((ranklist = (int *) malloc(nbytes)) == NULL)
		nomemory("ranklist");

    for (i=0;i<popsize;i++)     /* Fill index array with indices into oldpop. */
 	    ranklist[i] = i;    /* Since pop's fitnesses are in random order, */
 	                        /* the indices here are random as far as the  */
 	                        /* population is concerned.  Thus we don't    */
 	                        /* have to worry about a possible qsort       */
 	                        /* worst case scenario (from this             */
 	                        /* initialization, anyway.)                   */


/*           1                                   i - 1                        */
/*   p(i) = --- * (nu_max - (nu_max - nu_min) * ------- )                     */
/*          Lam                                 Lam - 1                       */
/*                                                                            */
/*   where 1 <= nu_max <= 2, and nu_min = 2 - nu_max.                         */
    	
    oneoverpopsize = (float) (1.0 / (float) popsize);	
    if (ranklist_probabilities)	
    	for (i = 0;i<popsize;i++)
    		{
    		 ranklist_probabilities[i] =  /* Note: i is already "i - 1", and Lambda is popsize. */
    		      oneoverpopsize * (rankfactor - (rankfactor - (2.0 - rankfactor)) * ((float) i) / (((float) popsize) - 1));
    		}

}

/* Here, you must free whatever you malloc above, done at end of each
subpopulation (Manypops) or run (Onepop). */

void select_free_rank() {
	if (ranklist != NULL)
    	free(ranklist); /* ANSI says its OK to free NULL in any event. */
    ranklist = NULL;    /* Clean up the pointer (now it's garbage.)     */
    if (ranklist_probabilities != NULL)
    	free(ranklist_probabilities);
    ranklist_probabilities = NULL;
    if (choices != NULL)
    	free(choices);
    choices = NULL;
}


/*      Function: rank_compare_greater                         */
/*      Description: Comparison function for qsort().          */
/*      Qsort requires a function pointer argument.  It is a   */
/*	    callback function to us, the user, to tell qsort       */
/*	    which element is greater.  We return an                */
/*	    int whose value is < 0 if e1 is greater, 0 if          */
/*	    they are equal, and > 0 if e2 is greater.  It is       */
/*	    up to us to define what greater means.                 */
/*      Input, Input Modifications, Return Values: Predefined  */
/*      by qsort() definition.  (see below)                    */


int rank_compare_greater_rank(const void *elem1, const void *elem2) {

  if (oldpop[*((int *) elem1)].fitness > oldpop[*((int *) elem2)].fitness)
    return(-1);
  else if (oldpop[*((int *) elem1)].fitness < oldpop[*((int *) elem2)].fitness)
    return(1);

  return(0);
}


/* Any setup stuff goes here, done ONCE per generation.  Uses stochastic */
/* universal sampling (like suselect.c), but based on linear ranking     */
/* values rather than fitness values.                                    */

void preselect_rank() {  
	

    int    i;
    int    j, k;
    float  pointer, sum;

    /* Faster to test once with two routines than to  */
    /* test within the rank_compare function itself.  */
    /* Remember: This is RANK based selection -- */
    /* fitness PER SE is never used!  Selection based */
    /* on relative POSITION only! */
    
	//?????qsort(ranklist, (size_t)popsize, sizeof(int), rank_compare_greater);
    
    if (fit_avg == 0.) {
	    for (j = 0; j < popsize; j++)
	        choices[j] = j;
    }
    else {
      k = 0;
      pointer = randomperc();
      sum = 0.0;
      for (j = 0; j < popsize; j++)
	for (sum += ranklist_probabilities[j] * (float) popsize; 
	     sum > pointer; pointer++)
	  choices[k++] = j;
    }
    nremain = popsize - 1;

}


/* This is called ONCE PER INDIVIDUAL TO BE SELECTED */


/*************************************************************/
/*     The suselect.c method is used, but running on the     */
/*     probabilities generated from the RANKING scheme, not  */
/*     on relative fitnesses, as happens when suselect.c is  */
/*     used alone as the selection method.                   */
/*     suselect.c method                                     */

int selection_rank() {


    int     jpick, slect;
    jpick = rnd(0, nremain);
    slect = choices[jpick];
    choices[jpick] = choices[nremain];
    nremain--;
    return (slect);

}



/*----------------------------------------------------------------------------*/
/*             roulette wheel selection.                                      */
/*----------------------------------------------------------------------------*/



void select_memory_roulette_wheel()
{
}

void select_free_roulette_wheel()
{
}



// In questo caso la preselezione serve per calcolare la somma totale delle fitness
void preselect_roulette_wheel()
{
    int     j;

    sumfitness = 0;
    for (j = 0; j < popsize; j++)
	sumfitness += oldpop[j].fitness;
}


/* roulette-wheel selection */
/* Bug in original SGA-C found by GALOPPS user Dan Judd; corrected */
/* March 09, 1995 */
int selection_roulette_wheel() {

    float   sum, pick;
    int     i;

    pick = randomperc();
    sum = 0;

    if (sumfitness != 0) {
	for (i = 0; (sum < pick) && (i < popsize); i++) {
	    sum += oldpop[i].fitness / sumfitness;
        }
        i--; /*decrement because the above loop always goes 1 too far.Quando i=0 sum =0 quindi sum<pick  sempre vera*/
    }
    else
	i = rnd(0, popsize - 1);

    return (i);
}



/*----------------------------------------------------------------------------*/
/* suselect.c - contains select_memory, select_free,                          */
/*         preselect, and select, for stochastic universal sampling method    */
/*         Reference is James Baker, Proceedings, Second International Conf.  */
/*         on Genetic Algorithms, pp.14-21, 1987, "Reducing Bias and          */
/*         Inefficency in the Selection Algorithm.  Coded for SGA by Erik     */
/*         Goodman, October 30, 1993.                                         */
/*----------------------------------------------------------------------------*/


/* allocates aux. memory for stochastic universal sampling selection */
void select_memory_SUS() {

  int nbytes;

  nbytes = popsize * sizeof(int);
  if ((choices = (int *) malloc(nbytes)) == NULL)
    nomemory("choices");
}


/* frees aux. memory for stochastic universal sampling selection */
void select_free_SUS() {

  free(choices);
  choices = NULL;
}

/* preselection for stochastic universal sampling method */
void preselect_SUS() {
  int     j, k;
  float   pointer, sum;

  if (fit_avg == 0.) {
    for (j = 0; j < popsize; j++)
      choices[j] = j;
  }
  else {
    k = 0;
    pointer = randomperc();
    sum = 0.0;
    for (j = 0; j < popsize; j++) {
      for (sum += (oldpop[j].fitness / fit_avg); sum > pointer; pointer++) {
	choices[k++] = j;
	if(k >= popsize) 
          break;
      }
      if(k >= popsize)
        break;
    }
  }
  nremain = popsize - 1;
}

/* selection using stochastic universal sampling method */
int selection_SUS() {

  int     jpick, slect;

  jpick = rnd(0, nremain);
  slect = choices[jpick];
  choices[jpick] = choices[nremain];
  nremain--;
  return (slect);
}



/*----------------------------------------------------------------------------*/
/* tselect.c - Tournament selection                                           */
/* Contributed by Hillol Kargupta, Dept of Engr. Mechanics, U. of Alabama     */
/* Input logic updated, moved to initialization, April 3, 1995, Erik Goodman. */
/*----------------------------------------------------------------------------*/




void select_memory_tournament() {

    unsigned nbytes;

    nbytes = popsize * sizeof(int);
    if ((tourneylist = (int *) malloc(nbytes)) == NULL)
	nomemory("tourneylist");
}


void select_free_tournament() {

    free(tourneylist);
    tourneylist = NULL;
}



void preselect_tournament() {

    reset();
    tourneypos = 0;
}


int selection_tournament() {

    int     pick, winner, i;

    /* If remaining members not enough for a tournament, then reset list */
    if ((popsize - tourneypos) < tourneysize) {
	reset();
	tourneypos = 0;
    }

    /* Select tourneysize structures at random and conduct a tournament */
    winner = tourneylist[tourneypos];
    for (i = 1; i < tourneysize; i++) {
	pick = tourneylist[i + tourneypos];
	if (oldpop[pick].fitness > oldpop[winner].fitness)
	    winner = pick;
    }

    /* Update tourneypos */
    tourneypos += tourneysize;
    return (winner);
}

/* Shuffles the tourneylist at random */
void reset() {

    int     i, rand1, rand2, temp;

    for (i = 0; i < popsize; i++)
	tourneylist[i] = i;

    for (i = 0; i < popsize; i++) {
	rand1 = rnd(i, popsize - 1);
	rand2 = rnd(i, popsize - 1);
	temp = tourneylist[rand1];
	tourneylist[rand1] = tourneylist[rand2];
	tourneylist[rand2] = temp;
    }
}





/*----------------------------------------------------------------------------*/
/* srselect.c - contains select_memory, select_free,                          */
/*              preselect, and select, stochastic remainder method            */
/*----------------------------------------------------------------------------*/


/* allocates auxiliary memory for stochastic remainder selection */
void select_memory_stochastic_remainder() {

    unsigned nbytes;

    nbytes = popsize * sizeof(int);
    if ((choices = (int *) malloc(nbytes)) == NULL)
	nomemory("choices");
    nbytes = popsize * sizeof(float);
    if ((fraction = (float *) malloc(nbytes)) == NULL)
	nomemory("fraction");
}

/* frees auxiliary memory for stochastic remainder selection */
void select_free_stochastic_remainder() {

    
    free(choices);
    choices = NULL;
    free(fraction);
    fraction = NULL;
}

/* preselection for stochastic remainder method */
void preselect_stochastic_remainder() {

    int     j, jassign, k;
    float   expected;

    if (fit_avg == 0.) {
	for (j = 0; j < popsize; j++)
	    choices[j] = j;
    }
    else {
	j = 0;
	k = 0;

	/* Assign whole numbers */
	do {
	    expected = ((oldpop[j].fitness) / fit_avg);
	    jassign = expected;
	    /* note that expected is automatically truncated */
	    fraction[j] = expected - jassign;
	    while (jassign > 0) {
		jassign--;
		choices[k] = j;
		k++;
	    }
	    j++;
	}
	while (j < popsize);

	j = 0;
	/* Assign fractional parts */
	while (k < popsize) {
	    if (j >= popsize)
		j = 0;
	    if (fraction[j] > 0.0) {
		/* A winner if true */
		if (flip(fraction[j])) {
		    choices[k] = j;
		    fraction[j] = fraction[j] - 1.0;
		    k++;
		}
	    }
	    j++;
	}
    }
    nremain = popsize - 1;
}

/* selection using remainder method */
int selection_stochastic_remainder() {

    int     jpick, slect;

    jpick = rnd(0, nremain);
    slect = choices[jpick];
    choices[jpick] = choices[nremain];
    nremain--;
    return (slect);
}




















