
#ifndef SGAFUNC_DEFINED
#define SGAFUNC_DEFINED

typedef unsigned char *BIGNUM;

#ifndef TRUE
#define TRUE    1
#define FALSE   0
#endif

#define FAIL    0
#define SUCC    1
#define SKIP    2

/* Line below is to define a max function, called maxx, which will not */
/* conflict with the max function which is defined on some systems, but */
/* NOT on others.  Using maxx in your appxxxxx.c routines is also */
/* recommended to avoid naming conflicts. */
#define maxx(n,m) (((n)>(m))? (n):(m)) 


// Prototipi di funzioni per outliers
//void Main_Program(void);
void funcs(double x[],double afunc[],int ma);



/* app?????.c (i.e., all app files) */
void  app_set_field_sizes();
int power (double base, int n);
void objfunc(struct individual *critter);
void objfunc_chorm(void);
int restituisci_statistica_int(int type_of_return);
double restituisci_statistica_real(int type_of_return);
void objfunc_print(void);
void app_set_options(void);
void application(void);
void app_read_prob_params();
void app_data(BOOL flag);
void app_init(void);
void app_user_init_pop(int starting_guy_index);
void app_after_random_init(void);
void app_initreport(void);
void app_report(void);
void app_quiet_report();
void app_print_strings(void);
void app_conv_rept(void);
void app_decide_if_converged(int *flag, int *number_to_replace);
void app_when_converged(void);
BOOL app_user_does_migration(struct individual *IndPop
			     , char *filename, int number_to_migrate
			     , BOOL want_best, int crowding_amount
			     , int incest_reduction_amount, int ChromSize
			     , int BestInd
			     , struct individual *migrant_holder);
BOOL app_transform_migrant(struct individual *migrant_holder
			   , int DonorChromsize
			   , struct individual *transformed_migrant
			   , char *filename);
BOOL app_transform_chrom_to_std(unsigned *mapped_saved_chromosome
				, unsigned *chrom_for_objfunc);
void app_generate(void);
void app_stats(struct individual *pop);
void app_before_inversion(void);
BOOL app_write_ckp_hdr(FILE *fp);
BOOL app_read_ckp_hdr(FILE *fp);
int  GetUtilitySize(void);
int  GetMaxUtilitySize(void);
void app_new_global_best_report(void);

/* file_state.c */
int init_write(char*);
FILE *start_write(char*, long*, int);
int end_write(char*, FILE*, long*, int);
int update_rstate(char*, int);
FILE *start_read(char*, int, int, unsigned long*, unsigned long*, int*);
int end_read(char*, FILE*, int, int, unsigned long, unsigned long, int, BOOL*);
int file_state_check(char*, long*, unsigned long*);
void get_bitflag(unsigned long*, unsigned long*, unsigned long*);

/* user_in.c */
void add_parameter(char*, char*, int);
char *get_parameter(char*, char*);
int parse_one_parameter(char*);
int trim_string(char*);
int delete_parameter(char*);
void pop_inputs(BOOL*);
void get_pop_overrides(void);
void subpop_data(BOOL*);
int commandline(int, char**);
void input_overrides(void);
void global_overrides(void);
void problem_inputs(void);
void usage(void);

/* Operator.c */
void crossover_oneptx(unsigned *parent1, unsigned *parent2, unsigned *child1, unsigned *child2, int jcross[2]);
void crossover_twoptx(unsigned *parent1, unsigned *parent2, unsigned *child1, unsigned *child2, int jcross[2]);
void crossover_uniform(unsigned *parent1, unsigned *parent2, unsigned *child1, unsigned *child2, int jcross[2]);
void crossover_cycle(unsigned *parent1, unsigned *parent2, unsigned *child1, unsigned *child2, int jcross[2]);
void crossover_uniform_order(unsigned *parent1, unsigned *parent2, unsigned *child1, unsigned *child2, int jcross[2]);
void crossover_pmx(unsigned *parent1, unsigned *parent2, unsigned *child1, unsigned *child2, int jcross[2]);
void crossover_order(unsigned *parent1, unsigned *parent2, unsigned *child1, unsigned *child2, int jcross[2]);
void crossover_app(unsigned *parent1, unsigned *parent2, unsigned *child1, unsigned *child2, int jcross[2]);

int  FirstNth(int *array,int k,int start,int end);

void mutation_bit(unsigned *child);
void field_mutation_bit(unsigned *child);
void mutation_multiple(unsigned *child);
void field_mutation_multiple(unsigned *child);
void mutation_scramble(unsigned *child);
void field_mutation_scramble(unsigned *child);
void mutation_swap(unsigned *child);
void field_mutation_swap(unsigned *child);

void mutation_app(unsigned *child);
void field_mutation_app(unsigned *child);


void select_memory_rank();
void select_free_rank();
void preselect_rank();
int selection_rank();
int rank_compare_greater_rank(const void *elem1, const void *elem2);


void select_memory_roulette_wheel();
void select_free_roulette_wheel();
void preselect_roulette_wheel();
int selection_roulette_wheel();

void select_memory_SUS();
void select_free_SUS();
void preselect_SUS();
int selection_SUS();

void select_memory_tournament();
void select_free_tournament();
void preselect_tournament();
int selection_tournament();


void select_memory_stochastic_remainder();
void select_free_stochastic_remainder();
void preselect_stochastic_remainder();
int selection_stochastic_remainder();

/* ffscanf.c */
int ffscanf(char *fieldname, FILE *fp, char *format, void *buffer);
int ffscanf2(char *fieldname, FILE *fp, char *format, void *buffer1,
void *buffer2);
int ffscanf4(char *fieldname, FILE *fp, char *format, void *buffer1,
void *buffer2, void *buffer3, void *buffer4);
void SetBufferInValid(void);

/* generate.c */
void generation(void);
void crowder_with_optional_incest_reduction(void);
void usualgen(void);
int  closest(int i);
void remap_then_objfunc(struct individual *critter);
void remap_then_objfunc2(struct individual *critter);
void sys_util_survive_without_eval(void);

/* invercla.c or invercir.c */
void inversion_standard(int *map);
void inversion_circular(int *map);


/* initsubp.c */
void initialize_parallel(BOOL *askrevise);
void revisedata(BOOL *Must_Recalculate_Bestnow);
void initdata(void);
void init_random_pop(int starting_guy_index);
void init_non_binary(int starting_guy_index);
void init_superuniform_pop(int starting_guy_index);
void initpermpop(int starting_guy_index);
void initreport_parallel();
void writeinitpop(void);
void initialize(void);
void initreport(void);
void Initialize_For_New_Individual(int j);
void initialize_inversion_map(int *map);

/* main*ga.c */
void subpopulation(BOOL *askrevise);
BOOL InitializeCumStats(void);
void SetUpMigration(void);
void RunWhichPops(void);
void DefineIO(int argc, char * argv[]);
void GetUniversalInputs(void);
void EndOfCycle(void);
void ModifyRunBasedOnConvergence(void);
void GetThisRunInputs(void);

/* memory.c */
void initmalloc(void);
void freeall(void);
void nomemory(char *string);
void malloc_field_sizes_arrays(void);
void MallocPermOperSpace(void);
void sys_util_free(void);
void sys_util_malloc(void);
BOOL sys_util_malloc_utility_field(int ** utilityfield);
void sys_util_malloc_bestever_utility(void);

/* random.c */
void advance_random(void);
int  flip( float prob );
void initrandomnormaldeviate();
double noise(double mu,double sigma);
void Randomize(float *seeds);
double randomnormaldeviate(void);
float randomperc(void);
double double_randomperd(void);
int  rnd(int low,int high);
unsigned rnd_max_uint(void);
float rndreal(float lo,float hi );
void warmup_random( float random_seed );

/* report.c */
void report(void);
void writepop(void);
void writechrom(unsigned *chrom);
void writefields(unsigned *chrom);
void reptconv(void);
void print_pct_conv(void);

/* select.c */
void select_memory(void);
void select_free(void);
void preselect(void);
int  selection(void);

/* statisti.c */
void statistics(struct individual *pop);
void convergemeasure(struct individual *pop);
void sigma_truncation(struct individual *pop);
void linear_scale(struct individual *pop);
void window_scaling(struct individual *pop);
void Boltzmann_scale(struct individual *pop);
void globalstats();
void count_ones_at_loci(unsigned *chrom);

/* utility.c */
void copyright(int parallel);
void repchar(FILE *outfp,char *ch,int repcount);
void skip(FILE *outfp,int skipcount);
int  ithruj2int(int i,int j,unsigned *from);
void int2ithruj(int i,int j,int value,unsigned *chrom);
int  getfield(int n,int nbroffields,unsigned *chrom);
int  getfield_uneq_flds(int n, int nbroffields,unsigned *chrom
			   , int *ends_of_fields);
void putfield(int n,int nbroffields,int value,unsigned *chrom);
void putfield_uneq_flds(int n, int nbroffields, int value, unsigned *chrom
			     , int *ends_of_fields);
long powerof2(int expon);
int  ceilinglogbase2(long longarg);
int  floorlogbase2(int intarg);
void chromtointarray(int *intarry,unsigned *chrom);
void chromtointarray_uneq_flds(int *intarray,unsigned *chrom
				  , int *ends_of_fields);
void intarraytochrom(int *intarray,unsigned *chrom);
int  hamming(struct individual *critter1,struct individual *critter2);
float indextofloat( long longint,long maxlongint,float lower,float upper );
long floattoindex( float floatvalue,float lower,float upper,long maxlongint );
void CombineFileName( char *Buffer,char *prefix, int whichpop, char *ext );
BOOL Lock(char *filename, int num_tries_to_fail);
BOOL Unlock(char *filename);
BOOL MakeLockable(char *filename);
BOOL map_chromosome_to_std(unsigned *chromosome_in, int *map
			   , unsigned *chromosome_out);
BOOL map_chromosome_to_std_uneq_flds(unsigned *chromosome_in, int *map
			   , unsigned *chromosome_out, int *ends_of_fields);
void KillTime(void);
void sys_util_copy_utility(int *dest, int *source);

/* Master.c & check*.c */
void SetBufferInValid( void );
BOOL GetMigrants( struct individual *IndArray, int donorpop, char * filename
		 , int number_to_migrate, BOOL want_best
		 , int migration_incest_reduction
		 , int migration_crowding_amount );
BOOL get_donor_pop_inversion_map_and_field_ends(int donor_pop_num);
BOOL ReadNeighborTable( char * filename );
void ReadFromNeighbor( int popno);
BOOL FileRename( char *prefix,char *oldext,char *newext, BOOL mustlocknew );
int  ReadCheckPointHeader(char *fname, BOOL (*CallBackFun)(FILE *fp)) ;
BOOL WriteCheckPointHeader(char *fname, BOOL (*CallBackFun)(FILE *fp));
void read_checkpointfile(char *filename, int numberwanted
			 , BOOL Must_Recalculate_Bestnow);
void write_checkpoint();
BOOL ReadCumStats(void);
BOOL UpdateCumStats(void);
void bestever_variable_malloc(void);
BOOL transform_inversion_pattern(unsigned *chrom_in_donor_pattern
				 , int *this_pop_map_to_std
				 , int *donor_pop_map_to_std
				 , unsigned *chrom_in_new_pattern);
BOOL transform_inversion_pattern_uneq_flds(unsigned *chrom_in_donor_pattern
				 , int *this_pop_map_to_std
				 , int *donor_pop_map_to_std
				 , unsigned *chrom_in_new_pattern
                                 , int *donor_pop_ends_of_fields);
void FreeUpMigrantHolder(void);
BOOL GetFitnessBiasedMigrant(int *jj);
BOOL sys_util_read_best_utility(FILE *fp);
BOOL sys_util_write_best_utility(FILE *fp);
BOOL sys_util_read_utility(int *UtilityBuf, FILE *fp);
BOOL sys_util_write_utility(int *UtilityBuf, FILE *fp);

#endif
