/*************************************************************************
* 
*    user_in.c
* 
*    file of routines to accept user input, interactive or from files, using
*    command line overrides
* 
*    routines:
*    int commandline(int, char**)
*    void global_overrides()
*    void get_pop_overrides()
*    void GetUniversalInputs()
*    static void SetUpMigration()
*    static void RunWhichPops()
*    void subpop_data(BOOL*)
*    void problem_inputs()
*    int pop_inputs(BOOL*)
*
*    Modified so can specify an output file, but input from keyboard,EDG,4/9/96
*    Changed several defaults to legal (sensible) values, EDG, 4/9/96
*    Added input for Boltzmann selection w/wo automatic scaling, EDG, 4/9/96
*    
*    includes code modified from 
*    lil-gp Genetic Programming System, version 0.9b
*      Douglas Zongker       (zongker@cps.msu.edu)
*      William F. Punch III   (punch@cps.msu.edu)
* 
*    static void add_parameter(char*, char*, int)
*    static char *get_parameter(char*, char*)
*    static int parse_one_parameter(char*)
*    static int trim_string(char*)
*    static int delete_parameter(char*)
* 
*    5-95
*    Erik D. Goodman (goodman@egr.msu.edu)
*    Leslie Thomas Hoppensteadt  (hoppen@egr.msu.edu)
* 
*    (c) 1993, 1994, 1995, 1996 Board of Trustees        
*           Michigan State University           
*/

#include "stdafx.h"
#include "MSetar.h"
#include "MSetarDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <stdio.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include "external.h"

#define MAXPARAMLINELENGTH    255
#define PARAM_COPY_NONE   0
#define PARAM_COPY_NAME   1
#define PARAM_COPY_VALUE  2
#define PARAMETER_MINSIZE       31
#define PARAMETER_CHUNKSIZE     16

typedef struct _parameter
{
  char *n;
  char *v;
  int copyflags;
} parameter;

static parameter *param;
static int param_size = 0, param_alloc = 0;











